## exim4 4.86.2

=== Makefile ===
# Top-level makefile for Exim; handles creating a build directory with
# appropriate links, and then creating and running the main makefile in that
# directory.

# Copyright (c) University of Cambridge, 1995 - 2015
# See the file NOTICE for conditions of use and distribution.

# IRIX make uses the shell that is in the SHELL variable, which often defaults
# to csh, so put this in to make it use the Bourne shell. In systems where
# /bin/sh is not a Bourne-compatible shell, this line will have to be edited,
# or "make" must be called with a different SHELL= setting.

SHELL=/bin/sh
RM_COMMAND=/bin/rm

# If a build name has not been specified by running this make file via a
# command of the form "make build=xxxx", then determine the name of the
# operating system and the machine architecture and use that. This does not
# provide an override for the OS type and architecture type; they still have
# to be used for the OS-specific files. To override them, you can set the
# shell variables OSTYPE and ARCHTYPE when running make.

buildname=$${build:-`$(SHELL) scripts/os-type`-`$(SHELL) scripts/arch-type`}

# The default target checks for the existence of Local/Makefile, that the main
# makefile is built and up-to-date, and then it runs it.

all: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS)


# This pair for the convinience of of the Debian maintainers
exim: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS) exim
utils: Local/Makefile configure
	@cd build-$(buildname); $(MAKE) SHELL=$(SHELL) $(MFLAGS) utils


Local/Makefile:
	@echo ""
	@echo "*** Please create Local/Makefile by copying src/EDITME and making"
	@echo "*** appropriate changes for your site."
	@echo ""
	@test ! -d Local && mkdir Local
	@false

# This is separated off so that "make build-directory" can be obeyed on
# its own if necessary.

build-directory:
	@builddir=build-$(buildname); \
	case "$$builddir" in *UnKnown*) exit 1;; esac; \
	$(SHELL) -c "test -d $$builddir -a -r $$builddir/version.c || \
	  (mkdir $$builddir; cd $$builddir; $(SHELL) ../scripts/MakeLinks)";

checks:
	$(SHELL) scripts/source_checks

# The "configure" target ensures that the build directory exists, then arranges
# to build the main makefile from inside the build directory, by calling the
# Configure-Makefile script. This does its own dependency checking because of
# the optional files.

configure: checks build-directory
	@cd build-$(buildname); \
	  build=$(build) $(SHELL) ../scripts/Configure-Makefile

# The "makefile" target forces a rebuild of the makefile (as opposed to
# "configure", which doesn't force it).

makefile: build-directory
	@cd build-$(buildname); $(RM_COMMAND) -f Makefile; \
	  build=$(build) $(SHELL) ../scripts/Configure-Makefile

# The installation commands are kept in a separate script, which expects
# to be run from inside the build directory.

install:        all
		@cd build-$(buildname); \
		build=$(build) $(SHELL) ../scripts/exim_install $(INSTALL_ARG)

# Tidy-up targets

clean:; @echo ""; echo '*** "make clean" just removes all .o and .a files'
	@echo '*** Use "make makefile" to force a rebuild of the makefile'
	@echo ""
	cd build-$(buildname); \
	$(RM_COMMAND) -f *.o lookups/*.o lookups/*.a auths/*.o auths/*.a \
	routers/*.o routers/*.a transports/*.o transports/*.a \
	pdkim/*.o pdkim/*.a

clean_exim:; cd build-$(buildname); \
	 $(RM_COMMAND) -f *.o lookups/*.o lookups/*.a auths/*.o auths/*.a \
	routers/*.o routers/*.a transports/*.o transports/*.a lookups/*.so

distclean:; $(RM_COMMAND) -rf build-* cscope*

cscope.files: FRC
	echo "-q" > $@
	echo "-p3" >> $@
	find src Local OS exim_monitor -name "*.[cshyl]" -print \
		    -o -name "os.h*" -print \
		    -o -name "*akefile*" -print \
		    -o -name config.h.defaults -print \
		    -o -name EDITME -print >> $@
	ls OS/* >> $@

FRC:

# End of top-level makefile

=== src/auths/Makefile ===
# Make file for building a library containing all the available authorization
# methods, and calling it auths.a. In addition, there are functions that are
# of general use in several methods; these are in separate modules so they are
# linked in only when needed. This Makefile is called from the main make file,
# after cd'ing to the auths subdirectory. When the relevant AUTH_ macros are
# defined, the equivalent modules herein is not included in the final binary.

OBJ = auth-spa.o b64decode.o b64encode.o call_pam.o call_pwcheck.o \
      call_radius.o check_serv_cond.o cram_md5.o cyrus_sasl.o dovecot.o \
      get_data.o get_no64_data.o gsasl_exim.o heimdal_gssapi.o \
      md5.o plaintext.o pwcheck.o sha1.o \
      spa.o tls.o xtextdecode.o xtextencode.o

auths.a:         $(OBJ)
		 @$(RM_COMMAND) -f auths.a
		 @echo "$(AR) auths.a"
		 $(FE)$(AR) auths.a $(OBJ)
		 $(RANLIB) $@

.SUFFIXES:       .o .c
.c.o:;           @echo "$(CC) $*.c"
		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c

auth-spa.o:         $(HDRS) auth-spa.c
b64encode.o:        $(HDRS) b64encode.c
b64decode.o:        $(HDRS) b64decode.c
call_pam.o:         $(HDRS) call_pam.c
call_pwcheck.o:     $(HDRS) call_pwcheck.c pwcheck.h
call_radius.o:      $(HDRS) call_radius.c
check_serv_cond.o:  $(HDRS) check_serv_cond.c
get_data.o:         $(HDRS) get_data.c
get_no64_data.o:    $(HDRS) get_no64_data.c
md5.o:              $(HDRS) md5.c
pwcheck.o:          $(HDRS) pwcheck.c pwcheck.h
sha1.o:             $(HDRS) sha1.c
xtextdecode.o:      $(HDRS) xtextdecode.c
xtextencode.o:      $(HDRS) xtextencode.c

cram_md5.o:         $(HDRS) cram_md5.c cram_md5.h
cyrus_sasl.o:       $(HDRS) cyrus_sasl.c cyrus_sasl.h
dovecot.o:          $(HDRS) dovecot.c dovecot.h
gsasl_exim.o:       $(HDRS) gsasl_exim.c gsasl_exim.h
heimdal_gssapi.o:   $(HDRS) heimdal_gssapi.c heimdal_gssapi.h
plaintext.o:        $(HDRS) plaintext.c plaintext.h
spa.o:              $(HDRS) spa.c spa.h
tls.o:              $(HDRS) tls.c tls.h

# End

=== src/lookups/Makefile ===
# Make file for building Exim's lookup modules.
# This is called from the main make file, after cd'ing
# to the lookups subdirectory.

# nb: at build time, the version of this file used will have had some
#     extra variable definitions and prepended to it and module build rules
#     interpolated below.

# MAGIC-TAG-MODS-OBJ-RULES-GO-HERE


all:             lookups.a lf_quote.o lf_check_file.o lf_sqlperform.o $(MODS)

lookups.a:       $(OBJ)
		 @$(RM_COMMAND) -f lookups.a
		 @echo "$(AR) lookups.a"
		 @$(AR) lookups.a $(OBJ)
		 $(RANLIB) $@

.SUFFIXES:       .o .c .so
.c.o:;           @echo "$(CC) $*.c"
		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c

.c.so:;          @echo "$(CC) -shared $*.c"
		 $(FE)$(CC) $(LOOKUP_$*_INCLUDE) $(LOOKUP_$*_LIBS) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) $(DLFLAGS) $*.c -o $@

lf_check_file.o: $(PHDRS) lf_check_file.c  lf_functions.h
lf_quote.o:      $(PHDRS) lf_quote.c       lf_functions.h
lf_sqlperform.o: $(PHDRS) lf_sqlperform.c  lf_functions.h

cdb.o:           $(PHDRS) cdb.c
dbmdb.o:         $(PHDRS) dbmdb.c
dnsdb.o:         $(PHDRS) dnsdb.c
dsearch.o:       $(PHDRS) dsearch.c
ibase.o:         $(PHDRS) ibase.c
ldap.o:          $(PHDRS) ldap.c
lsearch.o:       $(PHDRS) lsearch.c
mysql.o:         $(PHDRS) mysql.c
nis.o:           $(PHDRS) nis.c
nisplus.o:       $(PHDRS) nisplus.c
oracle.o:        $(PHDRS) oracle.c
passwd.o:        $(PHDRS) passwd.c
pgsql.o:         $(PHDRS) pgsql.c
redis.o:         $(PHDRS) redis.c
spf.o:           $(PHDRS) spf.c
sqlite.o:        $(PHDRS) sqlite.c
testdb.o:        $(PHDRS) testdb.c
whoson.o:        $(PHDRS) whoson.c

cdb.so:           $(PHDRS) cdb.c
dbmdb.so:         $(PHDRS) dbmdb.c
dnsdb.so:         $(PHDRS) dnsdb.c
dsearch.so:       $(PHDRS) dsearch.c
ibase.so:         $(PHDRS) ibase.c
ldap.so:          $(PHDRS) ldap.c
lsearch.so:       $(PHDRS) lsearch.c
mysql.so:         $(PHDRS) mysql.c
nis.so:           $(PHDRS) nis.c
nisplus.so:       $(PHDRS) nisplus.c
oracle.so:        $(PHDRS) oracle.c
passwd.so:        $(PHDRS) passwd.c
pgsql.so:         $(PHDRS) pgsql.c
redis.so:         $(PHDRS) redis.c
spf.so:           $(PHDRS) spf.c
sqlite.so:        $(PHDRS) sqlite.c
testdb.so:        $(PHDRS) testdb.c
whoson.so:        $(PHDRS) whoson.c

# End

=== src/transports/Makefile ===
# Make file for building a library containing all the available transports and
# calling it transports.a. This is called from the main make file, after cd'ing
# to the transports subdirectory.

OBJ = appendfile.o autoreply.o lmtp.o pipe.o smtp.o smtp_socks.o tf_maildir.o

transports.a:    $(OBJ)
		 @$(RM_COMMAND) -f transports.a
		 @echo "$(AR) transports.a"
		 @$(AR) transports.a $(OBJ)
		 $(RANLIB) $@

.SUFFIXES:       .o .c
.c.o:;           @echo "$(CC) $*.c"
		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c

appendfile.o:    $(HDRS) appendfile.c appendfile.h tf_maildir.h
autoreply.o:     $(HDRS) autoreply.c autoreply.h
lmtp.o:          $(HDRS) lmtp.c lmtp.h
pipe.o:          $(HDRS) pipe.c pipe.h
smtp.o:          $(HDRS) smtp.c smtp.h
smtp_socks.o:    $(HDRS) smtp_socks.c smtp.h

tf_maildir.o:    $(HDRS) tf_maildir.c tf_maildir.h appendfile.h

# End

=== debian/changelog ===
exim4 (4.86.2-2ubuntu2.6) xenial-security; urgency=medium

  * SECURITY UPDATE: Out-of-bounds read
    - debian/patches/CVE-2020-12783-*.patch: fix SPA
      authenticator, checking client-supplied data before using it
      in src/auths/spa.c, src/auths/spa-spa.c.
    - CVE-2020-12783

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Thu, 14 May 2020 09:54:21 -0300

exim4 (4.86.2-2ubuntu2.5) xenial-security; urgency=medium

  * SECURITY UPDATE: remote command execution
    - debian/patches/CVE-2019-15846.patch: ensure not to interpret '\\'
      before '\0' in src/string.c
    - CVE-2019-15846

 -- Alex Murray <alex.murray@canonical.com>  Thu, 05 Sep 2019 11:19:50 +0930

exim4 (4.86.2-2ubuntu2.4) xenial-security; urgency=medium

  * SECURITY UPDATE: code execution via ${sort }
    - debian/patches/CVE-2019-13917.patch: avoid re-expansion in ${sort }
      in src/expand.c.
    - CVE-2019-13917

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 19 Jul 2019 07:21:10 -0400

exim4 (4.86.2-2ubuntu2.3) xenial-security; urgency=medium

  * SECURITY UPDATE: Buffer overflow in base64d()
    - debian/patches/CVE-2018-6789.patch: fix overflow in
      src/auths/b64decode.c.
    - CVE-2018-6789

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Sat, 10 Feb 2018 14:18:40 -0500

exim4 (4.86.2-2ubuntu2.2) xenial-security; urgency=medium

  * SECURITY UPDATE: memory leak
    - debian/patches/93_CVE-2017-1000368.patch: free -p argument if
      allocation was required.
    - CVE-2017-1000368

 -- Steve Beattie <sbeattie@ubuntu.com>  Fri, 02 Jun 2017 22:07:28 -0700

exim4 (4.86.2-2ubuntu2.1) xenial-security; urgency=medium

  * SECURITY UPDATE: DKIM information leakage
    - debian/patches/CVE-2016-9963.patch: fix information leakage in
      src/dkim.c, src/transports/smtp.c.
    - CVE-2016-9963

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 05 Jan 2017 08:29:10 -0500

exim4 (4.86.2-2ubuntu2) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 12:21:41 +0000

exim4 (4.86.2-2ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian.control, debian/patches/fix_smtp_banner.patch
      + Show Ubuntu distribution in SMTP banner.
      + Build-Depends on lsb-release.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 15 Mar 2016 11:56:18 -0400

exim4 (4.86.2-2) unstable; urgency=high

  * Bump exim4-config Breaks to exim4-daemon-* (<< 4.86.2). Closes: #816790

 -- Andreas Metzler <ametzler@debian.org>  Sat, 05 Mar 2016 13:07:31 +0100

exim4 (4.86.2-1) unstable; urgency=high

  * Pull 75_0012_Cutthrough-Fix-bug-with-dot-only-line.patch from upstream
    4.86+fixes branch.
  * New upstream security release for CVE-2016-1531.
    + New options keep_environment/add_environment which are empty by default,
      i.e. any subprocesses start in a clean (empty) environment.
    + -C requires an absolute path.
    + Exim changes it's working directory to / right after startup.
  * Add macros MAIN_KEEP_ENVIRONMENT and MAIN_ADD_ENVIRONMENT to set the new
    options. If neither is used we use add_environment to set a minimal
    PATH=/bin:/usr/bin to avoid a runtime warning.

 -- Andreas Metzler <ametzler@debian.org>  Tue, 01 Mar 2016 19:34:39 +0100

exim4 (4.86-7ubuntu3) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:40:56 +0000

exim4 (4.86-7ubuntu2) xenial; urgency=medium

  * Rebuild for Perl 5.22.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Dec 2015 10:30:54 +0000

exim4 (4.86-7ubuntu1) xenial; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian.control, debian/patches/fix_smtp_banner.patch
      + Show Ubuntu distribution in SMTP banner.
      + Build-Depends on lsb-release.

 -- Pierre-André MOREY <pierre-andre.morey@canonical.com>  Mon, 14 Dec 2015 14:23:51 +0100

exim4 (4.86-7) unstable; urgency=medium

  * Allow arch-indep build (dpkg-buildpackage -A). Closes: #806023
  * 75_0011_MIME-fix-crash-on-filenames-having-null-charset.-Bug.patch from
    exim-4_86+fixes branch fixes another MIME ACL related crash.
    https://bugs.exim.org/show_bug.cgi?id=1730

 -- Andreas Metzler <ametzler@debian.org>  Sat, 28 Nov 2015 18:45:31 +0100

exim4 (4.86-6) unstable; urgency=medium

  * Cleanup (actual patch is identical): Use
    75_0009_Avoid-misaligned-access-in-cached-lookup.-Bug-1708.patch from
    exim-4_86+fixes branch instad of
    76_Avoid-misaligned-access-in-cached-lookup.-Bug-1708.patch.
  * Pull 75_0010_DKIM-ignore-space-tab-embedded-in-base64-during-deco.patch,
    DKIM: ignore space & tab embedded in base64 during decode.  Bug 1700

 -- Andreas Metzler <ametzler@debian.org>  Sun, 08 Nov 2015 07:55:51 +0100

exim4 (4.86-5) unstable; urgency=high

  * Pull 76_Avoid-misaligned-access-in-cached-lookup.-Bug-1708.patch from GIT
    head to avoid misaligned access in cached lookup. Closes: #803255

 -- Andreas Metzler <ametzler@debian.org>  Tue, 03 Nov 2015 19:33:49 +0100

exim4 (4.86-4) unstable; urgency=medium

  * Fix documentation of lowuid_aliases router, exceptions are in
    CONFDIR/lowuid-aliases not CONFDIR/lowuid_aliases. (Thanks, Tim Krah)
    Closes: #799672
  * fcron has been removed from Debian in 2011, stop listing it as an
    alternative dependency of exim4-base (Thanks, Alexandre Detiste).
    Closes: #798236
  * Update to upstream exim-4_86+fixes branch:
    + Drop 75_Fix-ESMTP-MAIL-command-option-processing.patch,
      76_Fix-post-transport-crash.patch,
      77_Fix-post-transport-crash-safeguard-for-missing-spool.patch,
      78_Close-logs-after-daemon-process-exceptional-write.patch.
    + Add 75_0001-Fix-post-transport-crash.patch
      75_0002-Fix-post-transport-crash-safeguard-for-missing-spool.patch
      75_0003-Fix-ESMTP-MAIL-command-option-processing.patch
      75_0005-Close-logs-after-daemon-process-exceptional-write.-B.patch


=== debian/control ===
Source: exim4
Section: mail
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
Uploaders: Andreas Metzler <ametzler@debian.org>,Marc Haber <mh+debian-packages@zugschlus.de>
Homepage: http://www.exim.org/
Standards-Version: 3.9.6
#Vcs-Git: git://git.debian.org/git/pkg-exim4/exim4.git
#Vcs-Browser: http://git.debian.org/?p=pkg-exim4/exim4.git
Vcs-Git: git://anonscm.debian.org/pkg-exim4/exim4.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-exim4/exim4.git
Build-Depends: debhelper (>= 9), po-debconf, docbook-xsl, xsltproc,
  lynx-cur | lynx, docbook-xml, libpcre3-dev, libldap2-dev, libpam0g-dev,
  libident-dev, libdb5.3-dev, libxmu-dev, libxt-dev, libxext-dev, libx11-dev,
  libxaw7-dev, libpq-dev, libmysqlclient-dev,
  libsqlite3-dev, libperl-dev, libgnutls28-dev, libsasl2-dev, lsb-release

Package: exim4-base
Architecture: any
Breaks: exim4-daemon-light (<<${Upstream-Version}),
 exim4-daemon-heavy (<<${Upstream-Version}), 
 exim4-daemon-custom (<<${Upstream-Version})
Conflicts: exim, exim-tls
Replaces: exim, exim-tls, exim4-daemon-light, exim4-daemon-heavy, exim4-daemon-custom
Depends: ${shlibs:Depends}, ${misc:Depends}, 
 cron | cron-daemon | anacron,
 exim4-config (>=4.82) | exim4-config-2, adduser, netbase, lsb-base (>= 3.0-6)
# psmisc just for exiwhat.
Recommends: psmisc, mailx, perl-modules
Suggests: mail-reader, eximon4, exim4-doc-html|exim4-doc-info, 
 gnutls-bin | openssl, file, spf-tools-perl, swaks
Description: support files for all Exim MTA (v4) packages
 Exim (v4) is a mail transport agent. exim4-base provides the support
 files needed by all exim4 daemon packages. You need an additional package
 containing the main executable. The available packages are:
 .
  exim4-daemon-light
  exim4-daemon-heavy
 .
 If you build exim4 from the source package locally, you can also
 build an exim4-daemon-custom package tailored to your own feature set.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-config
Architecture: all
Breaks: exim4-daemon-light (<< 4.86.2), exim4-daemon-heavy (<< 4.86.2)
Provides: exim4-config-2
Conflicts: exim, exim-tls, exim4-config, exim4-config-2, ${MTA-Conflicts}
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: configuration for the Exim MTA (v4)
 Exim (v4) is a mail transport agent. exim4-config provides the configuration
 for the exim4 daemon packages. The configuration framework has been split
 off the main package to allow sites to replace the configuration scheme
 with their own without having to change the actual exim4 packages.
 .
 Sites with special configuration needs (having a lot of identically
 configured machines for example) can use this to distribute their own
 custom configuration via the packaging system, using the magic
 available with dpkg's conffile handling, without having to do local
 changes on all of these machines.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-light
Architecture: any
Provides: mail-transport-agent, exim4-localscanapi-2.0,
 ${dist:Provides:exim4-daemon-light}
Conflicts: mail-transport-agent
Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends}, ${misc:Depends}
Description: lightweight Exim MTA (v4) daemon
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with only basic features enabled. It works well with the
 standard setups that are provided by Debian and includes support for
 TLS encryption and the dlopen patch to allow dynamic loading of a
 local_scan function.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4
Architecture: all
Depends: ${misc:Depends}, debconf (>= 1.4.69) | cdebconf (>= 0.39),
 exim4-base (>= ${source:Version}),
 exim4-base (<< ${source:Version}.1),
 exim4-daemon-light | exim4-daemon-heavy | exim4-daemon-custom
Description: metapackage to ease Exim MTA (v4) installation
 Exim (v4) is a mail transport agent. exim4 is the metapackage depending
 on the essential components for a basic exim4 installation.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: exim4-daemon-heavy
Architecture: any
Priority: optional
Provides: mail-transport-agent, exim4-localscanapi-2.0
Conflicts: mail-transport-agent
Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends},
 ${misc:Depends}
Breaks: clamav-daemon (<< 0.95)
Description: Exim MTA (v4) daemon with extended features, including exiscan-acl
 Exim (v4) is a mail transport agent. This package contains the exim4
 daemon with extended features. In addition to the features already
 supported by exim4-daemon-light, exim4-daemon-heavy includes LDAP,
 sqlite, PostgreSQL and MySQL data lookups, SASL and SPA SMTP authentication,
 embedded Perl interpreter, and the content scanning extension
 (formerly known as "exiscan-acl") for integration of virus scanners
 and spamassassin.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific
 FAQ list. Information about the way the Debian packages are
 configured can be found in
 /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
 information about the way the Debian binary packages are built. The
 very extensive upstream documentation is shipped in
 /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
 configuration process in a standard setup, invoke dpkg-reconfigure
 exim4-config. There is a Debian-centered mailing list,
 pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
 questions there, and only write to the upstream exim-users mailing
 list if you are sure that your question is not Debian-specific. You
 can find the subscription web page on
 http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

#Package: exim4-daemon-custom
#Architecture: any
#Priority: optional
#Provides: mail-transport-agent, exim4-localscanapi-2.0
#Conflicts: mail-transport-agent
#Replaces: mail-transport-agent, exim4-base (<= 4.61-1)
#Depends: exim4-base (>= ${Upstream-Version}), ${shlibs:Depends}, ${misc:Depends}
#Description: custom Exim MTA (v4) daemon with locally set features
# Exim (v4) is a mail transport agent. This package contains a
# custom-configured exim4 daemon compiled to local needs. This package
# is not part of official Debian, but can easily be built from the
# Debian source package. For information about the feature set compiled in,
# and for bug reports, please find out who built your package.
# .
# The Debian exim4 packages have their own web page,
# http://wiki.debian.org/PkgExim4. There is also a Debian-specific
# FAQ list. Information about the way the Debian packages are
# configured can be found in
# /usr/share/doc/exim4-base/README.Debian.gz, which additionally contains
# information about the way the Debian binary packages are built. The
# very extensive upstream documentation is shipped in
# /usr/share/doc/exim4-base/spec.txt.gz. To repeat the debconf-driven
# configuration process in a standard setup, invoke dpkg-reconfigure
# exim4-config. There is a Debian-centered mailing list,
# pkg-exim4-users@lists.alioth.debian.org. Please ask Debian-specific
# questions there, and only write to the upstream exim-users mailing
# list if you are sure that your question is not Debian-specific. You
# can find the subscription web page on
# http://lists.alioth.debian.org/mailman/listinfo/pkg-exim4-users

Package: eximon4
Architecture: any
Priority: optional
Conflicts: eximon
Replaces: eximon
Depends: ${shlibs:Depends}, ${misc:Depends}, exim4-base (>= 4.10)
Description: monitor application for the Exim MTA (v4) (X11 interface)
 Eximon is a helper program for the Exim MTA (v4). It allows
 administrators to view the mail queue and logs, and perform a variety
 of actions on queued messages, such as freezing, bouncing and thawing
 messages.

Package: exim4-dbg
Architecture: any
Priority: extra
Section: debug
Depends: exim4-base, exim4-config, ${misc:Depends}
Recommends: eximon4
Description: debugging symbols for the Exim MTA (utilities)
 Exim (v4) is a mail transport agent. This package contains
 debugging symbols for the binaries contained in the exim4
 packages. The daemon packages have their own debug package.
 .
 The Debian exim4 packages have their own web page,
 http://wiki.debian.org/PkgExim4. There is also a Debian-specific

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for exim4
# This file is public domain software, originally written by Joey Hess.
#
# Uncomment this to turn on verbose mode. 
# export DH_VERBOSE=1

buildname := $(shell scripts/os-type)-$(shell scripts/arch-type)
DEBIAN := $(shell pwd)/debian

ifeq ($(wildcard /usr/share/dpkg/buildflags.mk),) 
CFLAGS := -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif
else
export DEB_BUILD_MAINT_OPTIONS := hardening=+bindnow,+pie
DPKG_EXPORT_BUILDFLAGS := 1
include /usr/share/dpkg/buildflags.mk
endif

# The build system ignores CPPFLAGS, append them to CFLAGS
CFLAGS := $(CFLAGS) $(shell getconf LFS_CFLAGS) -D_LARGEFILE_SOURCE -fno-strict-aliasing -Wall $(CPPFLAGS)
export CFLAGS
# LFLAGS is used where GNU would use LDFLAGS
export LFLAGS += $(LDFLAGS)

LC_ALL=C
export LC_ALL

# Which packages should we build?
ifndef buildbasepackages
buildbasepackages=yes
endif

ifndef extradaemonpackages
extradaemonpackages=exim4-daemon-heavy
endif
# If you want to build a daemon with a configuration tailored to YOUR special
# needs, uncomment the two custom packages in debian/control
# call "fakeroot debian/rules unpack-configs", copy EDITME.exim4-light
# to EDITME.exim4-custom and modify it. Please note that you _need_ to
# modify EDITME.exim4-custom or your build will fail due to #386188.
#
# If you want to create multiple custom packages with different names, use
# the script debian/create-custom-package [suffix].
#
# Afterwards EITHER change the definition of extradaemonpackages above OR
# simply set extradaemonpackages to the desired value via the environment.

# If you want your changes to survive a debian/rules clean, call
# "fakeroot debian/rules pack-configs" after customizing EDITME.exim4-custom

# If you remove exim4-daemon-light from basedaemonpackages to prevent
# exim4-daemon-light from being built, you need to modify the build
# process to pull the helper binaries from the daemon package that you
# actually build. If you simply remove exim4-daemon-light here, you will
# end up with exim4-base sans binaries, which is most probably not what
# you intend to have.
#
# combined[ai]dbgpackage has a list of packages whose debug information
# goes into the combined debug package exim4-dbg, separated as arch
# independent and arch dependent list.
# extraadbgpackage has a list of packages whose debug information
# goes into one debug package foo-dbg per package. This is currently
# only implemented and needed for arch dependent packages.

ifeq ($(buildbasepackages),yes)
basedaemonpackages=exim4-daemon-light
combinedadbgpackage=exim4-base eximon4
combinedidbgpackage=exim4-config exim4
exim4dbg=exim4-dbg
dhstripparm=--dbg-package=$(exim4dbg)
exim4dev=exim4-dev
extraadbgpackage=$(basedaemonpackages) $(extradaemonpackages)
else
basedaemonpackages=
combinedadbgpackage=
combinedidbgpackage=
exim4dbg=
dhstripparm=
exim4dev=
extraadbgpackage=$(extradaemonpackages)
endif
#DEBUGOUT:=$(shell echo >&2 buildbasepackages $(buildbasepackages))
#DEBUGOUT:=$(shell echo >&2 extradaemonpackages $(extradaemonpackages))

# If you want to build with OpenSSL instead of GnuTLS, uncomment this
# OPENSSL:=1
# Please note that building exim4-daemon-heavy with OpenSSL is a GPL
# violation.


# list of all arch dependent packages to be built
buildpackages=$(combinedadbgpackage) $(extraadbgpackage) $(addsuffix -dbg,$(extraadbgpackage)) $(exim4dbg) $(exim4dev)
# generate -pexim4-base -peximon4 ... commandline for debhelper
dhbuildpackages=$(addprefix -p,$(buildpackages))
dhcombinedadbgpackage=$(addprefix -p,$(combinedadbgpackage))
dhcombinedidbgpackage=$(addprefix -p,$(combinedidbgpackage))

# exim4-daemon-heavy --> b-exim4-daemon-heavy/build-Linux-x86_64/exim
daemonbinaries=$(addprefix b-,$(addsuffix /build-$(buildname)/exim,$(extradaemonpackages)))
debiandaemonbinaries=$(addprefix $(DEBIAN)/,$(addsuffix /usr/sbin/exim4,$(extradaemonpackages)))
BDIRS=$(addprefix b-,$(extradaemonpackages) $(basedaemonpackages))


# get upstream-version from debian/changelog, i.e. anything until the first -
DEBVERSION := $(shell dpkg-parsechangelog | sed -n '/^Version: /s/^Version: //p')
UPSTREAMVERSION := $(shell echo $(DEBVERSION) | sed -n 's/\(.\+\)-[^-]\+/\1/p')
MTACONFLICTS := $(shell cat $(DEBIAN)/mtalist)
DEBTIME := $(shell dpkg-parsechangelog --show-field Date)
REPBUILDDATE := \
	$(shell env LC_ALL=C TZ=UTC date --date="$(DEBTIME)" '+%b %e %Y')
REPBUILDTIME := \
	$(shell env LC_ALL=C TZ=UTC date --date="$(DEBTIME)" '+%H:%M:%S')

PROVIDE_DEFAULT_MTA := $(shell if dpkg-vendor --is Ubuntu || \
	dpkg-vendor --derives-from Ubuntu ; then : ; else \
	echo "default-mta" ; fi)
# for reproducible build. If set exim would use $TZ as default value for
# TIMEZONE_DEFAULT
undefine TZ
unexport TZ


# set up build directory b-exim4-daemon-heavy/
$(addsuffix /Makefile,$(BDIRS)): %/Makefile:
	mkdir $*
	find . -mindepth 1 -maxdepth 1 \
		-name debian -prune -o \
		-name 'b-*' -o -print0 | \
		xargs --no-run-if-empty --null \
		cp -a --target-directory=$*
	printf '#define REPBUILDDATE "$(REPBUILDDATE)"\n' \
		> $*/src/repbuildtime.h && \
		printf '#define REPBUILDTIME "$(REPBUILDTIME)"\n' \
		>> $*/src/repbuildtime.h


unpack-configs: unpack-configs-stamp
unpack-configs-stamp: src/EDITME exim_monitor/EDITME
	patch -o EDITME.eximon exim_monitor/EDITME \
		$(DEBIAN)/EDITME.eximon.diff
	patch -o EDITME.exim4-light src/EDITME \
		$(DEBIAN)/EDITME.exim4-light.diff
ifdef OPENSSL
	patch EDITME.exim4-light $(DEBIAN)/EDITME.openssl.exim4-light.diff
endif
	-for editme in $(DEBIAN)/EDITME.exim4-*.diff; do \
	  if [ "$$editme" != "$(DEBIAN)/EDITME.exim4-light.diff" ]; then \
	    TARGETNAME=`basename $$editme .diff`; \
	    echo patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
	    patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
	  fi; \
	done
	touch unpack-configs-stamp

pack-configs:
	-diff -u src/EDITME EDITME.exim4-light \
		> $(DEBIAN)/EDITME.exim4-light.diff
	-for editme in EDITME.exim4-*; do \
	  if [ "$$editme" != "EDITME.exim4-light" ]; then \
	    echo diff -u EDITME.exim4-light $$editme; \
	    diff -u EDITME.exim4-light $$editme > $(DEBIAN)/$${editme}.diff; \
	  fi; \
	done
	-diff -u exim_monitor/EDITME EDITME.eximon \
		> $(DEBIAN)/EDITME.eximon.diff

# only called manually by maintainer before upload.
update-mtaconflicts:
	which grep-available > /dev/null && \
		grep-available --show-field=Package --field=Provides \
		mail-transport-agent --no-field-names \
		/var/lib/apt/lists/*Packages | grep -v exim | sort -u | \
		tr '\n' ',' | sed -e 's/,/, /g;s/, $$//' > $(DEBIAN)/mtalist

# Generate README.Debian as text/html ...
debian/README.Debian.html: debian/README.Debian.xml
	xsltproc --nonet --stringparam section.autolabel 1 \
		-o $@ \
		/usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
		$<
# ... and text/plain
debian/README.Debian: debian/README.Debian.html
	chmod 755 $(DEBIAN)/lynx-dump-postprocess
	lynx -force_html -dump $< | $(DEBIAN)/lynx-dump-postprocess > $@.tmp
	mv $@.tmp $@

configure: configure-stamp

configure-stamp: $(addsuffix /Makefile,$(BDIRS)) unpack-configs-stamp
	dh_testdir
	# Add here commands to configure the package.
	# We currently do not want to build depend on debhelper 7.2.3 just to
	# keep it from installing the wrong upstream changelog. 490937
	rm -fv CHANGES
	touch $@ 

# Build binaries for the base package, the eximon4 package, and the
# exim4-daemon-light package.
b-exim4-daemon-light/build-$(buildname)/exim: b-exim4-daemon-light/Makefile configure-stamp
	@echo build $(<D)
	dh_testdir

	rm -rf $(@D)
	mkdir -p $(<D)/Local
	cp EDITME.exim4-light $(<D)/Local/Makefile
	cp EDITME.eximon $(<D)/Local/eximon.conf
	cd $(<D) && $(MAKE) FULLECHO=''

b-exim4-daemon-heavy/build-$(buildname)/exim: b-exim4-daemon-heavy/Makefile configure-stamp
	@echo build $(<D)
	dh_testdir

	rm -rf $(@D)
	mkdir -p $(<D)/Local
	cp EDITME.exim4-heavy $(<D)/Local/Makefile
	cd $(<D) && $(MAKE) FULLECHO=''

## exim4 4.87

=== src/pdkim/Makefile ===
# Make file for building the pdkim library.

OBJ = pdkim.o hash.o rsa.o

pdkim.a:         $(OBJ)
		 @$(RM_COMMAND) -f pdkim.a
		 @echo "$(AR) pdkim.a"
		 $(FE)$(AR) pdkim.a $(OBJ)
		 $(RANLIB) $@

.SUFFIXES:       .o .c
.c.o:;           @echo "$(CC) $*.c"
		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) -I. $*.c

pdkim.o:            $(HDRS) crypt_ver.h hash.h blob.h pdkim.h pdkim.c
hash.o:             $(HDRS) crypt_ver.h hash.h blob.h pdkim.h hash.c
rsa.o:              $(HDRS) crypt_ver.h rsa.h blob.h rsa.c

# End

=== debian/changelog ===
exim4 (4.87-3ubuntu1) yakkety; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    + Show Ubuntu distribution in SMTP banner.
    + Build-Depends on lsb-release (needed for the Ubuntu SMTP banner patch)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 26 Jul 2016 13:30:09 +0200

exim4 (4.87-3) unstable; urgency=medium

  * Pull multiple patches from upstream GIT:
    + 71_01_configure.default-nice-message-for-overlong-lines-Bu.patch
      Improved message on overlong lines in example config.
    + 71_02_Delivery-quieten-smtp-transport-conn-reuse-vs.-deliv.patch
      Fix race condition related to connection reuse.
      https://bugs.exim.org/show_bug.cgi?id=1810
    + 71_03_Avoid-exposing-passwords-in-log-on-failing-ldap-look.patch
      71_04_Avoid-exposing-passwords-in-log-on-failing-ldap-look.patch
      Avoid exposing passwords in log on failing ldap lookup
      expansion. https://bugs.exim.org/show_bug.cgi?id=165
  * Copy information message on rejecting overlong lines in data ACL from
    upstream example configuration. Closes: #823418
  * Add NEWS entry on line-lenght-limit introduced in 4.87~RC1-1.
    Closes: 821830

 -- Andreas Metzler <ametzler@debian.org>  Sun, 08 May 2016 14:03:10 +0200

exim4 (4.87-2) unstable; urgency=medium

  * Fix reference to README.Debian in 01_exim4-config_listmacrosdefs.
    (Thanks, L. Guruprasad!) Closes: #821416
  * Add REMOTE_SMTP_SMARTHOST_HOSTS_REQUIRE_TLS macro to enforce TLS
    connections (hosts_require_tls option) in remote_smtp_smarthost
    transport. Closes: #822174
  * exim4-daemon-heavy: Disable WITH_OLD_DEMIME ("demime" ACL condition). It
    is deprecated and will be removed in 4.88.
  * README.Debian*: Fix minor issues  found by lintian.
  * Fix reference to spec.txt in 30_exim4-config_check_rcpt. Closes: #665399
  * Drop exim4-base Recommends on perl-modules. This had been unnecessary
    since 4.80~rc6-1 which dropped /usr/share/exim4/timeout.pl.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 30 Apr 2016 13:38:29 +0200

exim4 (4.87-1) unstable; urgency=medium

  * Fix comment in
    conf.d/transport/30_exim4-config_remote_smtp_smarthost. (Thanks,
    Jörg-Volker Peetz!) Closes: #819780
  * New upstream release.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 07 Apr 2016 19:26:59 +0200

exim4 (4.87~RC7-1) unstable; urgency=low

  * Enable SOCKS support in both -light and -heavy. Closes: #818091
  * Fix typos in configuration. (Thanks, Vincent Lefevre!) Closes: #819482
  * New upstream version.
    + Drop 74_Store-the-initial-working-directory.diff,
      75_String-expansions-fix-extract.patch,
      76_only_warn_on_nonempty_environment.diff.
    + Update debian/example.conf.md5.

 -- Andreas Metzler <ametzler@debian.org>  Fri, 01 Apr 2016 19:04:07 +0200

exim4 (4.87~RC6-3) unstable; urgency=medium

  * Merge changelog entries for 4.86.2-1 and -2.
  * Upload to unstable.
  * Add link to CVE details to latest NEWS entry and bump its version and date
    to match this upload. Closes: #818349, #817244

 -- Andreas Metzler <ametzler@debian.org>  Wed, 23 Mar 2016 18:44:22 +0100

exim4 (4.87~RC6-2) experimental; urgency=medium

  * 74_Store-the-initial-working-directory.diff,
    76_only_warn_on_nonempty_environment.diff: Upstream followups on the
    CVE fix (Thanks, Heiko Schlittermann!):
    + Runtime warning is only generated if (and only if) keep_environment
      is unset and environment is nonempty.
    + Store the initial working directory and make it available in the new
      expansion variable $initial_cwd.
  * Merge all NEWS.Debian files into a single one, identical for all binary
    packages. - Different NEWS files built from a single source package is not
    and has not ever been supported by apt-listchanges which is the most
    important frontend.
  * Add a NEWS entry about the environment related runtime warning.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 19 Mar 2016 18:11:32 +0100

exim4 (4.87~RC6-1) experimental; urgency=medium

  * New upstream version.
  * Add 75_String-expansions-fix-extract.patch from upstream GIT, fixing
    ${extract } string expansion for the numeric/3-string case. (Bug was
    introduced in 4.85.)
  * Set keep_environment to empty value instead of setting a minimal PATH in
    add_environment.

 -- Andreas Metzler <ametzler@debian.org>  Fri, 11 Mar 2016 19:50:07 +0100

exim4 (4.87~RC5-2) experimental; urgency=medium

  * Update debian/upstream/signing-key.asc, using the keys listed in
    ftp://ftp.exim.org/pub/exim/Exim-Maintainers-Keyring.asc. This adds
    Heiko Schlittermann's key.
  * Bump exim4-config Breaks to exim4-daemon-* (<< 4.87~RC5). Closes: #816790

 -- Andreas Metzler <ametzler@debian.org>  Sat, 05 Mar 2016 13:17:01 +0100

exim4 (4.87~RC5-1) experimental; urgency=medium

  * exim4-config.postinst: Test for existence of /etc/inetd.conf before trying
    to grep in it. Closes: #814998
  * New upstream version, includes the patch for CVE-2016-1531. (Local root
    exploit).
  * Add macros MAIN_KEEP_ENVIRONMENT and MAIN_ADD_ENVIRONMENT to set the new
    options. If neither is used we use add_environment to set a minimal
    PATH=/bin:/usr/bin to avoid a runtime warning.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 02 Mar 2016 21:06:43 +0100

exim4 (4.87~RC3-2) experimental; urgency=medium

  * README.Debian: Refer to Exim specification by chapter name instead of
    chapter number. Closes: #813351
  * Fix some spelling errors found by lintian.
  * Minor debian/rules cleanup:
    + Restore originally intended behavior, upstream changelog is only
      shipped in exim4-base, symlinks to it elsewhere.
    + Drop workaround for #347577, fixed in debhelper 5.0.15.
    + Use "dh binary-arch" and "dh binary-indep" and a bunch of override
      targets instead of listing all dh-commands. While this is uglier and
      slows things down a bit it shortens debian/rules by 40 lines and has the


=== debian/control ===
--- 
+++ 
@@ -5,11 +5,9 @@
 XSBC-Original-Maintainer: Exim4 Maintainers <pkg-exim4-maintainers@lists.alioth.debian.org>
 Uploaders: Andreas Metzler <ametzler@debian.org>,Marc Haber <mh+debian-packages@zugschlus.de>
 Homepage: http://www.exim.org/
-Standards-Version: 3.9.6
-#Vcs-Git: git://git.debian.org/git/pkg-exim4/exim4.git
-#Vcs-Browser: http://git.debian.org/?p=pkg-exim4/exim4.git
-Vcs-Git: git://anonscm.debian.org/pkg-exim4/exim4.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-exim4/exim4.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/pkg-exim4/exim4.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-exim4/exim4.git
 Build-Depends: debhelper (>= 9), po-debconf, docbook-xsl, xsltproc,
   lynx-cur | lynx, docbook-xml, libpcre3-dev, libldap2-dev, libpam0g-dev,
   libident-dev, libdb5.3-dev, libxmu-dev, libxt-dev, libxext-dev, libx11-dev,
@@ -27,7 +25,7 @@
  cron | cron-daemon | anacron,
  exim4-config (>=4.82) | exim4-config-2, adduser, netbase, lsb-base (>= 3.0-6)
 # psmisc just for exiwhat.
-Recommends: psmisc, mailx, perl-modules
+Recommends: psmisc, mailx
 Suggests: mail-reader, eximon4, exim4-doc-html|exim4-doc-info, 
  gnutls-bin | openssl, file, spf-tools-perl, swaks
 Description: support files for all Exim MTA (v4) packages
@@ -59,7 +57,7 @@
 
 Package: exim4-config
 Architecture: all
-Breaks: exim4-daemon-light (<< 4.86.2), exim4-daemon-heavy (<< 4.86.2)
+Breaks: exim4-daemon-light (<< 4.87~RC5), exim4-daemon-heavy (<< 4.87~RC5)
 Provides: exim4-config-2
 Conflicts: exim, exim-tls, exim4-config, exim4-config-2, ${MTA-Conflicts}
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
@@ -236,3 +234,5 @@
  .
  The Debian exim4 packages have their own web page,
  http://wiki.debian.org/PkgExim4. There is also a Debian-specific
+ FAQ list. Information about the way the Debian packages are
+ configured can be found in

=== debian/rules ===
--- 
+++ 
@@ -70,7 +70,6 @@
 ifeq ($(buildbasepackages),yes)
 basedaemonpackages=exim4-daemon-light
 combinedadbgpackage=exim4-base eximon4
-combinedidbgpackage=exim4-config exim4
 exim4dbg=exim4-dbg
 dhstripparm=--dbg-package=$(exim4dbg)
 exim4dev=exim4-dev
@@ -78,14 +77,11 @@
 else
 basedaemonpackages=
 combinedadbgpackage=
-combinedidbgpackage=
 exim4dbg=
 dhstripparm=
 exim4dev=
 extraadbgpackage=$(extradaemonpackages)
 endif
-#DEBUGOUT:=$(shell echo >&2 buildbasepackages $(buildbasepackages))
-#DEBUGOUT:=$(shell echo >&2 extradaemonpackages $(extradaemonpackages))
 
 # If you want to build with OpenSSL instead of GnuTLS, uncomment this
 # OPENSSL:=1
@@ -98,7 +94,6 @@
 # generate -pexim4-base -peximon4 ... commandline for debhelper
 dhbuildpackages=$(addprefix -p,$(buildpackages))
 dhcombinedadbgpackage=$(addprefix -p,$(combinedadbgpackage))
-dhcombinedidbgpackage=$(addprefix -p,$(combinedidbgpackage))
 
 # exim4-daemon-heavy --> b-exim4-daemon-heavy/build-Linux-x86_64/exim
 daemonbinaries=$(addprefix b-,$(addsuffix /build-$(buildname)/exim,$(extradaemonpackages)))
@@ -109,7 +104,6 @@
 # get upstream-version from debian/changelog, i.e. anything until the first -
 DEBVERSION := $(shell dpkg-parsechangelog | sed -n '/^Version: /s/^Version: //p')
 UPSTREAMVERSION := $(shell echo $(DEBVERSION) | sed -n 's/\(.\+\)-[^-]\+/\1/p')
-MTACONFLICTS := $(shell cat $(DEBIAN)/mtalist)
 DEBTIME := $(shell dpkg-parsechangelog --show-field Date)
 REPBUILDDATE := \
 	$(shell env LC_ALL=C TZ=UTC date --date="$(DEBTIME)" '+%b %e %Y')
@@ -148,11 +142,12 @@
 ifdef OPENSSL
 	patch EDITME.exim4-light $(DEBIAN)/EDITME.openssl.exim4-light.diff
 endif
-	-for editme in $(DEBIAN)/EDITME.exim4-*.diff; do \
+	for editme in $(DEBIAN)/EDITME.exim4-*.diff; do \
 	  if [ "$$editme" != "$(DEBIAN)/EDITME.exim4-light.diff" ]; then \
 	    TARGETNAME=`basename $$editme .diff`; \
 	    echo patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
-	    patch -o $$TARGETNAME EDITME.exim4-light $$editme; \
+	    patch -o $$TARGETNAME EDITME.exim4-light $$editme || \
+	    exit $$? ;\
 	  fi; \
 	done
 	touch unpack-configs-stamp
@@ -194,9 +189,6 @@
 configure-stamp: $(addsuffix /Makefile,$(BDIRS)) unpack-configs-stamp
 	dh_testdir
 	# Add here commands to configure the package.
-	# We currently do not want to build depend on debhelper 7.2.3 just to
-	# keep it from installing the wrong upstream changelog. 490937
-	rm -fv CHANGES
 	touch $@ 
 
 # Build binaries for the base package, the eximon4 package, and the
@@ -220,3 +212,20 @@
 	cp EDITME.exim4-heavy $(<D)/Local/Makefile
 	cd $(<D) && $(MAKE) FULLECHO=''
 
+b-exim4-daemon-custom/build-$(buildname)/exim: b-exim4-daemon-custom/Makefile configure-stamp
+	@echo build $(<D)
+	dh_testdir
+
+	rm -rf $(@D)
+	mkdir -p $(<D)/Local
+	cp EDITME.exim4-custom $(<D)/Local/Makefile
+	cd $(<D) && $(MAKE) FULLECHO=''
+
+build-indep: build-indep-stamp
+build-indep-stamp: debian/README.Debian
+	dh_testdir
+	touch $@
+
+build-arch: build-arch-stamp test-stamp
+
+ifeq ($(buildbasepackages),yes)
